# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "somehal"
version = "0.7.0"
authors = ["周睿 <zrufo747@outlook.com>"]
build = "build.rs"
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "SomeHAL: A hardware abstraction layer for kernel development."
readme = "README.md"
keywords = [
    "arceos",
    "kernel",
]
categories = [
    "os",
    "no-std",
]
license = "Apache-2.0"
repository = "https://github.com/rcore-os/tgoskits"

[features]
efi = ["someboot/efi"]
hv = [
    "mmu",
    "someboot/hv",
]
mmu = ["someboot/mmu"]
percpu-prealloc = ["someboot/percpu-prealloc"]
thead-mae = ["someboot/thead-mae"]
uspace = [
    "mmu",
    "someboot/uspace",
]

[lib]
name = "somehal"
path = "src/lib.rs"

[dependencies.anyhow]
version = "1.0"
default-features = false

[dependencies.kernutil]
version = "0.2.2"

[dependencies.log]
version = "0.4"

[dependencies.mmio-api]
version = "0.2.2"

[dependencies.page-table-generic]
version = "0.7.3"

[dependencies.rdif-intc]
version = "0.14.3"

[dependencies.rdrive]
version = "0.23.0"

[dependencies.someboot]
version = "0.2.1"

[dependencies.somehal-macros]
version = "0.1.4"

[dependencies.spin]
version = "0.12"

[dependencies.thiserror]
version = "2"
default-features = false

[dependencies.tock-registers]
version = "0.10"

[target.'cfg(target_arch = "aarch64")'.dependencies.aarch64-cpu]
version = "11"

[target.'cfg(target_arch = "aarch64")'.dependencies.arm-gic-driver]
version = "0.17.4"
features = ["rdif"]

[target.'cfg(target_arch = "loongarch64")'.dependencies.loongArch64]
version = "0.2"

[target.'cfg(target_arch = "riscv64")'.dependencies.ax-riscv-plic]
version = "0.4.7"

[target.'cfg(target_arch = "riscv64")'.dependencies.riscv]
version = "0.16.1"
default-features = false

[target.'cfg(target_arch = "riscv64")'.dependencies.sbi-rt]
version = "0.0.4"
features = ["legacy"]
default-features = false

[target.'cfg(target_arch = "x86_64")'.dependencies.x2apic]
version = "0.5"

[target.'cfg(target_arch = "x86_64")'.dependencies.x86]
version = "0.52"
